leetcode 452. Minimum Number of Arrows to Burst Balloons

简介:
1
2
3
4
5
There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it's horizontal, y-coordinates don't matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.
An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.
Example:
Input:[[10,16], [2,8], [1,6], [7,12]]
Output:2Explanation:One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).

题意:一堆气球,X轴方向,有一个起始位置和结束位置。现在准备射箭打气球,问最少需要几只箭才能射破全部气球。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
class  Solution {
     public  int  findMinArrowShots( int [][] points) {
         if  (points ==  null  || points.length ==  0  || points[ 0 ].length ==  0 ) {
             return  0 ;
         }
         int  row = points.length;
         int  col = points[ 0 ].length;
         Arrays.sort(points,  new  Comparator< int []>() {
             public  int  compare( int [] a,  int [] b) {
                 return  a[ 1 ] - b[ 1 ];
             }
         });
         int  start = points[ 0 ][ 0 ], end = points[ 0 ][ 1 ], ret =  1 ;
         for ( int  i =  1 ; i < row; i++){
             if (points[i][ 0 ] <= end){
                 //end = points[i][1];
                 //start = points[i][0];
                 continue ;
             }
             ret++;
             end = points[i][ 1 ];
         }
         return  ret;
     }
}

第一种方法是固定气球的终止位置,然后从前往后遍历,当遇到的气球的起始位置小于之前的终止位置,则表示可以一支箭射破这些气球。当大于的时候,则需要一只新箭。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
public  class  Solution {
     public  int  findMinArrowShots( int [][] points) {
         if (points ==  null  || points.length <  1 return  0 ;
         Arrays.sort(points, (a, b)->(a[ 0 ]-b[ 0 ]));
         int  result =  1 ;
         int  end = points[ 0 ][ 1 ];
         for ( int  i =  1 ; i < points.length; i ++) {
             if (points[i][ 0 ] > end) {
                 result ++;
                 end = points[i][ 1 ];
             else  {
                 end = Math.min(end, points[i][ 1 ]);
             }
         }
         return  result;
     }
}

第二种方法是固定气球的起始位置,比较新气球的起始位置和前气球的终止位置,不断缩小气球的公共区域,直到最后不能缩小位置。


本文转自 努力的C 51CTO博客,原文链接:http://blog.51cto.com/fulin0532/1969945

相关文章
|
算法
Leetcode 313. Super Ugly Number
题目翻译成中文是『超级丑数』,啥叫丑数?丑数就是素因子只有2,3,5的数,7 14 21不是丑数,因为他们都有7这个素数。 这里的超级丑数只是对丑数的一个扩展,超级丑数的素因子不再仅限于2 3 5,而是由题目给定一个素数数组。与朴素丑数算法相比,只是将素因子变了而已,解法还是和朴素丑数一致的。
99 1
|
5月前
|
存储 SQL 算法
LeetCode 题目 65:有效数字(Valid Number)【python】
LeetCode 题目 65:有效数字(Valid Number)【python】
|
6月前
|
存储 算法
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
45 0
|
存储
Leetcode Single Number II (面试题推荐)
给你一个整数数组,每个元素出现了三次,但只有一个元素出现了一次,让你找出这个数,要求线性的时间复杂度,不使用额外空间。
39 0
|
算法
LeetCode 414. Third Maximum Number
给定一个非空数组,返回此数组中第三大的数。如果不存在,则返回数组中最大的数。要求算法时间复杂度必须是O(n)。
94 0
LeetCode 414. Third Maximum Number
|
算法
LeetCode 405. Convert a Number to Hexadecimal
给定一个整数,编写一个算法将这个数转换为十六进制数。对于负整数,我们通常使用 补码运算 方法。
95 0
LeetCode 405. Convert a Number to Hexadecimal
|
API
LeetCode 375. Guess Number Higher or Lower II
我们正在玩一个猜数游戏,游戏规则如下: 我从 1 到 n 之间选择一个数字,你来猜我选了哪个数字。 每次你猜错了,我都会告诉你,我选的数字比你的大了或者小了。 然而,当你猜了数字 x 并且猜错了的时候,你需要支付金额为 x 的现金。直到你猜到我选的数字,你才算赢得了这个游戏。
110 0
LeetCode 375. Guess Number Higher or Lower II
|
API
LeetCode 374. Guess Number Higher or Lower
我们正在玩一个猜数字游戏。 游戏规则如下: 我从 1 到 n 选择一个数字。 你需要猜我选择了哪个数字。 每次你猜错了,我会告诉你这个数字是大了还是小了。
76 0
LeetCode 374. Guess Number Higher or Lower
|
算法
LeetCode 321. Create Maximum Number
给定长度分别为 m 和 n 的两个数组,其元素由 0-9 构成,表示两个自然数各位上的数字。现在从这两个数组中选出 k (k <= m + n) 个数字拼接成一个新的数,要求从同一个数组中取出的数字保持其在原数组中的相对顺序。 求满足该条件的最大数。结果返回一个表示该最大数的长度为 k 的数组。
71 0
LeetCode 321. Create Maximum Number
|
存储
LeetCode 313. Super Ugly Number
编写一段程序来查找第 n 个超级丑数。 超级丑数是指其所有质因数都是长度为 k 的质数列表 primes 中的正整数。
97 0
LeetCode 313. Super Ugly Number